#include "CEGUI/String.h"
#include "CEGUI/GeometryBuffer.h"
#include "CEGUI/RenderEffect.h"
#include "CEGUI/Texture.h"
#include "CEGUI/TextureTarget.h"
#include "CEGUI/RenderTarget.h"
#include "CEGUI/GUIContext.h"
#include "CEGUI/Vertex.h"


#include "CEGUI/RendererModules/OpenGL/StandardShaderFrag.h"
#include "CEGUI/RendererModules/OpenGL/StandardShaderVert.h"

#include "CEGUI/RendererModules/OpenGL/GlmPimpl.h"
#include "CEGUI/RendererModules/OpenGL/GLXPBTextureTarget.h"
#include "CEGUI/RendererModules/OpenGL/GL.h"
#include "CEGUI/RendererModules/OpenGL/RendererBase.h"
#include "CEGUI/RendererModules/OpenGL/GLRenderer.h"

#include "CEGUI/RendererModules/OpenGL/ViewportTarget.h"
#include "CEGUI/RendererModules/OpenGL/TextureTarget.h"
#include "CEGUI/RendererModules/OpenGL/GLFBOTextureTarget.h"
#include "CEGUI/RendererModules/OpenGL/GeometryBufferBase.h"
#include "CEGUI/RendererModules/OpenGL/GLGeometryBuffer.h"
#include "CEGUI/RendererModules/OpenGL/ShaderManager.h"

#include "CEGUI/RendererModules/OpenGL/Texture.h"

#include "CEGUI/RendererModules/OpenGL/GL3Renderer.h"
#include "CEGUI/RendererModules/OpenGL/Shader.h"
#include "CEGUI/RendererModules/OpenGL/StateChangeWrapper.h"
#include "CEGUI/RendererModules/OpenGL/RenderTarget.h"



// First we create a magic namespace to hold all our aliases
namespace pyplusplus
{
    namespace aliases
    {
        typedef CEGUI::OpenGLRenderTarget<CEGUI::RenderTarget> OpenGLRenderTargetTexture;
        typedef CEGUI::OpenGLRenderTarget<CEGUI::TextureTarget>  OpenGLRenderTargetRender;

        //typedef std::vector<CEGUI::BatchInfo> BatchList;
        //typedef std::vector<CEGUI::GLVertex> VertexList;
        typedef std::vector<CEGUI::TextureTarget*> TextureTargetList;
        typedef std::vector<CEGUI::OpenGLGeometryBufferBase*> GeometryBufferList;
        typedef unsigned int GLuint;

}
}
// this is a gcc-only workaround, don't do this at build time
#ifdef __GCCXML__

namespace python_CEGUI
{
    namespace details
    {
        inline void instantiate()
        {
        sizeof(CEGUI::OpenGLRenderTarget<CEGUI::TextureTarget>);
        sizeof(CEGUI::OpenGLRenderTarget<CEGUI::RenderTarget>);
        //sizeof(std::vector<CEGUI::BatchInfo> BatchList);
        //sizeof(std::vector<CEGUI::GLVertex> VertexList);
        sizeof(std::vector<CEGUI::TextureTarget*>);
        sizeof(std::vector<CEGUI::OpenGLGeometryBufferBase*>);

        }
    }
}

#endif
